// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2022, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



using System;
using Hiperscan.ApoIdentCore.Enums;
using Hiperscan.Unix;

namespace Hiperscan.ApoIdentCore.ComplexFinder
{
    public class ReferencingControl
    {
        public void SetState(ProgramState reference_type)
        {
            this.ReferencingType = reference_type;
        }

        public void StopWaitingForReference()
        {
            this.IsWaiting = false;
        }

        public void WaitForReference()
        {
            this.IsWaiting = true;

            for (; ; )
            {
                if (this.IsAborted)
                    break;

                if (this.IsWaiting == false)
                    break;

                System.Threading.Thread.Sleep(20);
            }
        }

        public void CheckForAbortReferencing()
        {
            System.Threading.Thread.Sleep(100);

            if (this.IsAborted)
                throw new Exception(Catalog.GetString("Recalibration procedure was not finished. Please repeat the measurement."));
        }

        public void AbortReferencing()
        {
            this.IsAborted = true;
        }

        public void Reset()
        {
            this.ReferencingType = ProgramState.None;
            this.IsAborted = false;
        }

        private bool IsWaiting { get; set; }
        public ProgramState ReferencingType { get; private set; }
        public bool IsAborted { get; private set; }
    }
}
